#!/bin/sh
#
### BEGIN INIT INFO
# Required-Start: coredump-setup.sh 
# Required-Stop:
# Should-Start:
# Should-Stop:
# Default-Start: S
# Default-Stop: 0 1 2 3 4 5 6
# Short-Description: Prepare coredump environmnent.
# Description: Prepare coredump environmnent.
### END INIT INFO 
# chkconfig: S 99 0

COREDUMP_SETUP=/etc/default/coredump-setup

case "$1" in
	start)
		echo -n "Preparing coredump environment: "

		if [ -f ${COREDUMP_SETUP} ]
		then
			. ${COREDUMP_SETUP}
		else
			echo -n "MISSING ${COREDUMP_SETUP} FILE - THERE WILL BE NO CORES: "
			MOUNT_PATH=/
			CORES_DIR=dev
			CORE_NAME=null
		fi

		if [ `mount | grep " on ${MOUNT_PATH} " | grep -c "(rw,"` -gt 0 ]
		then
			mkdir -p ${MOUNT_PATH}/${CORES_DIR}
			chmod a+rwx ${MOUNT_PATH}/${CORES_DIR}
			echo "${MOUNT_PATH}/${CORES_DIR}/${CORE_NAME}" > /proc/sys/kernel/core_pattern
			if [ $? -eq 0 ]
			then
				echo DONE.
			else
				echo FAILED!
			fi
		else
			echo FAILED!
		fi
		;;
	stop)
		;;
	*)
		echo "Usage: /etc/init.d/coredump_setup.sh {start|stop}"
		exit 1
esac

exit 0
