#!/bin/sh
#
# Name: ipmiboardpos.sh
# Date: 2012-06-01
# Author: Iskratel d.o.o
### BEGIN INIT INFO
# Required-Start:  
# Required-Stop:
# Should-Start:
# Should-Stop:
# Default-Start: S
# Default-Stop: 0 6
# Short-Description: Set board position through ipmidaemon
# Description: 
### END INIT INFO 
#chkconfig: S 60 -
#

export KLISHBOARDPOS=/sbin/cfg-getparams.sh
export IPMIBOARDPOS=/opt/iskratel/sbin/ipmiboardpos
export MYBOARDPOS=/tmp/myboardpos
export MYBOARDNAME=/tmp/myboardname

function itBoardName ()
{
    echo ${1} | sed '
    s/MPCBL.*/CVI/
    s/PCA,ATCA.*/CVK/
    s/AT8060.*/CVM/'
}

if [ -e /sbin/system-board-info ]
then
	/sbin/system-board-info --product-name-hi > $MYBOARDNAME

        IPMIBOARDNAME=`$IPMIBOARDPOS`
	RET=$?
        IT_BOARDNAME=`itBoardName ${IPMIBOARDNAME}`     # convert to Iskratel standard board identity (3-character)

        if [ $RET -eq 31 ]
        then
                echo "1" > $MYBOARDPOS
        else
                echo "${RET}" > $MYBOARDPOS
        fi

elif [ -x ${IPMIBOARDPOS} ]
then
	IPMIBOARDNAME=`$IPMIBOARDPOS`
	RET=$?
	IT_BOARDNAME=`itBoardName ${IPMIBOARDNAME}`	# convert to Iskratel standard board identity (3-character)

	if [ $RET -eq 31 ]
	then
		echo "1" > $MYBOARDPOS
	else
		echo "${RET}" > $MYBOARDPOS
	fi

	if [ "x${IPMIBOARDNAME}" != "x" ]
	then
		echo "${IT_BOARDNAME}" > $MYBOARDNAME
	else
		echo "BRD" > $MYBOARDNAME
	fi
else
	echo "1" > $MYBOARDPOS
	echo "BRD" > $MYBOARDNAME
fi

if [ -x ${KLISHBOARDPOS} ]
then
	RET=`${KLISHBOARDPOS} boardPos`
	if [ $RET -gt 0 ]
	then
		echo $RET > $MYBOARDPOS
	fi
fi

#Last check - if error set board_pos to 1. This will lead to alarm 1000870 - Unconsistent DB data - main unit data missing
BOARD_POS=`cat "$MYBOARDPOS"`
if [ "$BOARD_POS" -lt "1" ] || [ "$BOARD_POS" -gt "20" ]
then
	echo "1" > $MYBOARDPOS
fi
exit 0
                                        
