#!/bin/sh

###########################################################################
#                                                                         #
#                                                                         #
#              Copyright (c) 2007 IskraTEL                                #
#                                                                         #
#                                                                         #
#                                                                         #
#   Name        : extModRepSend.sh                                        #
#                                                                         #
#   Description : Script for sending diagnostic error reports to          #
#                 extModRepSend program                                   #
#                                                                         #
#   Position    : /opt/iskratel/sbin                                      #
#                                                                         #
#   Code        : QCDS - XAK4875                                          #
#                                                                         #
#   Date        : Aug 2007                                                #
#                                                                         #
#   Author      : Marjan Andelkovic ITPSP2                                #
#                                                                         #
#   Translation : * None                                                  #
#                                                                         #
#   Remarks     : * None                                                  #
#                                                                         #
#   Revisions   : * None                                                  #
#                                                                         #
###########################################################################

#/****************************************************************/
#/*          UNIX - SCCS  VERSION DESCRIPTION                    */
#/****************************************************************/
# static char unixid[] = "@(#)QCDS.z	1.1	09/02/09	extModRepSend.sh -O-";

#. /etc/init.d/it_functions
#it_set_it_profile

case "$1" in
        help)
		echo "Usage: extModRepSend.sh <mes_type> <errcod> <obj_ident> "
		echo "       mes_type - message type"
		echo "       errCode - error code"
		echo "       obj_ident - object identification string"
		echo " "
		echo "Example 1: extModRepSend.sh announce 900240 1.1/79.4/26.5"
		echo "Example 2: extModRepSend.sh retreate 900240 1.1/79.4/26.5"
        ;;
        announce)
		while read LINE; do
			/opt/iskratel/sbin/extModRepSend $@
			echo $LINE >> /var/log/announce.log
		done
        ;;
        retreate)
                while read LINE; do
                        /opt/iskratel/sbin/extModRepSend $@
			echo $LINE >> /var/log/retreate.log
                done
        ;;
        *)
	echo "Usage: extModRepSend.sh <mes_type> <errcod> <obj_ident> "
	echo "       mes_type - message type"
	echo "       errCode - error code"
	echo "       obj_ident - object identification string"
	echo " "
	echo "Example 1: extModRepSend.sh announce 900240 1.1/79.4/26.5"
	echo "Example 2: extModRepSend.sh retreate 900240 1.1/79.4/26.5"
        exit 1

;;
esac




