if [ "$1" == "" ] || [ "$2" == "" ]
then
	echo "Usage: proc_trace show <PID> (timeout[s])"
	echo "       proc_trace limits <PID>"
	echo "       proc_trace files <PID> (timeout[s])"
	echo "       proc_trace status <PID> (timeout[s])"
	exit
fi

cat /proc/$2/cmdline
echo ""
echo ""


if [ "$3" == "" ]
then
	if [ "$1" == "show" ]
	then
	        pidstat -I -h -r -u -v -p $2
	        echo "----------------------------------------------------"
	        echo ""
	        free
        	exit
	elif [ "$1" == "limits" ]
	then
		cat /proc/$2/limits
		exit
	elif [ "$1" == "files" ]
	then
	        files=$(ls -l /proc/$2/fd/* | wc -l)
	        echo "Number of opened files for PID=$2 is:"
	        echo "$files"
	        echo "Check /proc/$2/fd/ for details"
		exit
	elif [ "$1" == "status" ]
	then
		cat /proc/$2/status
		exit
	else
		echo "Wrong command"
		exit
	fi
else
	while [ 1 ]
	do
	        if [ "$1" == "show" ]
	        then
	                pidstat -I -h -r -u -v -p $2
	                echo "----------------------------------------------------"
	                echo ""
	                free
	                echo "======================================================================================================================================="
	                echo ""
	                echo ""
	                sleep $3
		elif [ "$1" == "files" ]
	        then
	                files=$(ls -l /proc/$2/fd/* | wc -l)
	                echo "Number of opened files for PID=$2 is:"
	                echo "$files"
	                sleep $3
		elif [ "$1" == "status" ]
	        then
	                cat /proc/$2/status
	                echo "======================================================================================================================================="
	                sleep $3 
	        else
	                echo "Wrong command"
	                exit
	        fi
	done
fi
