#!/bin/bash
# Crude address database

########################################################################
#                                                                      #
#                                                                      #
#               Copyright (c) 2011 Iskratel                            #
#                                                                      #
#                                                                      #
# Name:         syslog-ngConfigurator.sh                               #
#                                                                      #
# Description:  adds module and severity levels to syslog-ng.conf file #
#                                                                      #
# Code:                                                                #
#                                                                      #
# Date:         Mar 2012                                               #
#                                                                      #
# Author:       Bor Debelak, ITP RD AS1                                #
#                                                                      #
# Design:       /                                                      #
#                                                                      #
# Revisions:    /                                                      #
#                                                                      #
# Remarks:      /                                                      #
#                                                                      #
########################################################################

#help file
function f_help() {

echo;
echo "###########################################";
echo "##SYSLOG-NG CONFIGURATOR version 1.2 HELP##";
echo "###########################################";
echo;
echo "Script syslog-ngConfigurator.sh offers you to change severity for different modules (in file syslog-ng.conf).";
echo "";
echo "Firstly you have to severity.";
echo "";
echo "After that you choose a module.";
echo "";
echo "Then you have 2 options: either add another module or write chosen module(s) and severity levels to syslog-ng file.";
echo "";
echo "Logs based on chosen module(s) and severity will be written in \"/var/log/sc_print_p\".";
echo "";
echo "After you find out what you wanted, you should run the script again and choose this option: \"Return syslog-ng file to default state\".";
echo "";
}

#main menu
function mainMenu() {

echo "";
echo "Choose an option:";

echo "1) Add severity and module(s) to syslog-ng file"
echo "2) Return syslog-ng file to default state"
echo "x) Exit"

read option
case "$option" in
	"1" )
	changeConf;	
	;;	
	"2" )
	defaultConf;	
	;;
	"x" | "X" )
	exit;
	;;
	* )
	echo "Invalid selection.";
	;;
esac

}

#choose module
function moduleMenu() {

echo "";
echo "Add a module:";
echo "0) all"
echo "1) s_scp.rtdb"
echo "2) s_scp.dsp"
echo "3) s_scp.system"
echo "4) s_scp.sdl"
echo "5) s_scp.tracer"
echo "6) s_scp.ppp"
echo "7) s_scp.diag"	
echo "8) s_scp.v52"
echo "9) s_scp.vvs"
echo "10) s_scp.ssn7"
echo "11) s_scp.level1"
echo "12) s_scp.file_sys"
echo "13) s_scp.motsw"
echo "14) s_scp.atm"
echo "15) s_scp.h323"
echo "16) s_scp.bridge"	
echo "17) s_scp.pipc"
echo "18) s_scp.vxml"	
echo "19) s_scp.rtcp"
echo "20) s_scp.sip"
echo "21) s_scp.drh"
echo "22) s_scp.cdcp"
echo "23) s_scp.charge"	
echo "24) s_scp.replmgr"
echo "25) s_scp.kkipc"
echo "26) s_scp.hata"
echo "27) s_scp.ds"
echo "28) s_scp.c_prot"	
echo "29) s_scp.sctp"
echo "30) s_scp.sysup"
echo "31) s_scp.cas"
echo "32) s_scp.lim"
echo "33) s_scp.dbc"
echo "34) s_scp.gad"
echo "35) s_scp.exc"
echo "x) don't add any other module"

read option
case "$option" in

	"0" )
	flagChange=0;
	unset MODULE;
	i=0;
	MODULE[i]="s_scp.rtdb"; i=$((i+1));
	MODULE[i]="s_scp.dsp"; i=$((i+1));
	MODULE[i]="s_scp.system"; i=$((i+1));
	MODULE[i]="s_scp.sdl"; i=$((i+1));
	MODULE[i]="s_scp.tracer"; i=$((i+1));	
	MODULE[i]="s_scp.ppp"; i=$((i+1));
	MODULE[i]="s_scp.diag"; i=$((i+1));
	MODULE[i]="s_scp.v52"; i=$((i+1));
	MODULE[i]="s_scp.vvs"; i=$((i+1));
	MODULE[i]="s_scp.ssn7"; i=$((i+1));	
	MODULE[i]="s_scp.level1"; i=$((i+1));
	MODULE[i]="s_scp.file_sys"; i=$((i+1));
	MODULE[i]="s_scp.motsw"; i=$((i+1));
	MODULE[i]="s_scp.atm"; i=$((i+1));
	MODULE[i]="s_scp.h323"; i=$((i+1));	
	MODULE[i]="s_scp.bridge"; i=$((i+1));
	MODULE[i]="s_scp.pipc"; i=$((i+1));
	MODULE[i]="s_scp.vxml"; i=$((i+1));
	MODULE[i]="s_scp.rtcp"; i=$((i+1));
	MODULE[i]="s_scp.sip"; i=$((i+1));	
	MODULE[i]="s_scp.drh"; i=$((i+1));
	MODULE[i]="s_scp.cdcp"; i=$((i+1));
	MODULE[i]="s_scp.charge"; i=$((i+1));
	MODULE[i]="s_scp.replmgr"; i=$((i+1));
	MODULE[i]="s_scp.kkipc"; i=$((i+1));	
	MODULE[i]="s_scp.hata"; i=$((i+1));
	MODULE[i]="s_scp.ds"; i=$((i+1));
	MODULE[i]="s_scp.c_prot"; i=$((i+1));
	MODULE[i]="s_scp.sctp"; i=$((i+1));
	MODULE[i]="s_scp.sysup"; i=$((i+1));
	MODULE[i]="s_scp.cas"; i=$((i+1));
	MODULE[i]="s_scp.lim"; i=$((i+1));
	MODULE[i]="s_scp.dbc"; i=$((i+1));
	MODULE[i]="s_scp.gad"; i=$((i+1));
	MODULE[i]="s_scp.exc"; i=$((i+1));
	flagModule=1;
	;;
	"1" )
	MODULE[i]="s_scp.rtdb";
	i=$((i+1));
	flagModule=1;
	;;
	"2" )
	MODULE[i]="s_scp.dsp";
	i=$((i+1));
	flagModule=1;
	;;
	"3" )
	MODULE[i]="s_scp.system";
	i=$((i+1));
	flagModule=1;
	;;	
	"4" )
	MODULE[i]="s_scp.sdl";
	i=$((i+1));	
	flagModule=1;
	;;
	"5" )
	MODULE[i]="s_scp.tracer";
	i=$((i+1));
	flagModule=1;
	;;
	"6" )
	MODULE[i]="s_scp.ppp";
	i=$((i+1));
	flagModule=1;
	;;		
	"7" )
	MODULE[i]="s_scp.diag";
	i=$((i+1));
	flagModule=1;
	;;
	"8" )
	MODULE[i]="s_scp.v52";
	i=$((i+1));
	flagModule=1;
	;;
	"9" )
	MODULE[i]="s_scp.vvs";
	i=$((i+1));
	flagModule=1;
	;;	
	"10" )
	MODULE[i]="s_scp.ssn7";
	i=$((i+1));
	flagModule=1;
	;;
	"11" )
	MODULE[i]="s_scp.level1";
	i=$((i+1));
	flagModule=1;
	;;
	"12" )
	MODULE[i]="s_scp.file_sys";
	i=$((i+1));
	flagModule=1;
	;;
	"13" )
	MODULE[i]="s_scp.motsw";
	i=$((i+1));
	flagModule=1;
	;;
	"14" )
	MODULE[i]="s_scp.atm";
	i=$((i+1));	
	flagModule=1;
	;;
	"15" )
	MODULE[i]="s_scp.h323";
	i=$((i+1));
	flagModule=1;
	;;
	"16" )
	MODULE[i]="s_scp.bridge";
	i=$((i+1));
	flagModule=1;
	;;	
	"17" )
	MODULE[i]="s_scp.pipc";
	i=$((i+1));	
	flagModule=1;
	;;
	"18" )
	MODULE[i]="s_scp.vxml";
	i=$((i+1));
	flagModule=1;
	;;
	"19" )
	MODULE[i]="s_scp.rtcp";
	i=$((i+1));
	flagModule=1;
	;;		
	"20" )
	MODULE[i]="s_scp.sip";
	i=$((i+1));	
	flagModule=1;
	;;
	"21" )
	MODULE[i]="s_scp.drh";
	i=$((i+1));
	flagModule=1;
	;;
	"22" )
	MODULE[i]="s_scp.cdcp";
	i=$((i+1));
	flagModule=1;
	;;	
	"23" )
	MODULE[i]="s_scp.charge";
	i=$((i+1));
	flagModule=1;
	;;
	"24" )
	MODULE[i]="s_scp.replmgr";
	i=$((i+1));
	flagModule=1;
	;;
	"25" )
	MODULE[i]="s_scp.kkipc";
	i=$((i+1));
	flagModule=1;
	;;
	"26" )
	MODULE[i]="s_scp.hata";
	i=$((i+1));
	flagModule=1;
	;;	
	"27" )
	MODULE[i]="s_scp.ds";
	i=$((i+1));
	flagModule=1;
	;;
	"28" )
	MODULE[i]="s_scp.c_prot";
	i=$((i+1));
	flagModule=1;
	;;
	"29" )
	MODULE[i]="s_scp.sctp";
	i=$((i+1));
	flagModule=1;
	;;		
	"30" )
	MODULE[i]="s_scp.sysup";
	i=$((i+1));
	flagModule=1;
	;;
	"31" )
	MODULE[i]="s_scp.cas";
	i=$((i+1));
	flagModule=1;
	;;
	"32" )
	MODULE[i]="s_scp.lim";
	i=$((i+1));
	flagModule=1;
	;;	
	"33" )
	MODULE[i]="s_scp.dbc";
	i=$((i+1));	
	flagModule=1;
	;;
	"34" )
	MODULE[i]="s_scp.gad";
	i=$((i+1));
	flagModule=1;
	;;	
	"35" )
	MODULE[i]="s_scp.exc";
	i=$((i+1));
	flagModule=1;
	;;	
	"x" )
	flagModule=1;
	;;
	* )
	echo "Invalid selection.";
	;;
esac

return;
}
function moduleMenuMain() {

flagChange=1;
unset MODULE;
MODULE[0]="";
i=0;

while [[ ${MODULE[0]} == "" ]]
do
	flagModule=0;
	while [[ $flagModule -eq 0 ]]
	do	
		moduleMenu;
	done
done

while [[ $flagChange -eq 1 ]]
do
	echo "";
	echo "Choose an option:";
	echo "1) Add another module";
	echo "2) Write chosen severity and module(s) to syslog-ng file:";
	echo "   Severity: $severity";
	printf "   Module(s): ";
	for (( i=0 ; i < ${#MODULE[@]} ; i++ ))
	do
		printf "${MODULE[$i]}";
		if [[ $((i+1)) < ${#MODULE[@]} ]]
		then
			printf ", ";
		fi
	done
	printf "\n";
	echo "x) Exit"

	read option
	case "$option" in
		"1" )
		flagModule=0;
		while [[ $flagModule -eq 0 ]]
		do
			moduleMenu;	
		done
		;;	
		"2" )
		flagChange=0;
		;;
		"x" | "X" )
		exit;
		;;
		* )
		echo "Invalid selection.";
		;;
	esac
done
	
}

#choose severity
function severityMenu() {

echo "";	
echo "Choose severity:";

echo "0) emergency" #0 Emergency: system is unusable
echo "1) alert"     #1 Alert: action must be taken immediately
echo "2) crtical"   #2 Critical: critical conditions
echo "3) error"     #3 Error: error conditions
echo "4) warning"   #4 Warning: warning conditions
echo "5) notice"    #5 Notice: normal but significant condition
echo "6) info"      #6 Informational: informational messages
echo "7) debug"     #7 Debug: debug-level messages

read option
case "$option" in
	"0" )
	severity="emergency";	
	flagSeverity=1;
	;;
	"1" )
	severity="alert";	
	flagSeverity=1;
	;;
	"2" )
	severity="crtical";	
	flagSeverity=1;
	;;
	"3" )
	severity="error";	
	flagSeverity=1;
	;;
	"4" )
	severity="warning";	
	flagSeverity=1;
	;;
	"5" )
	severity="notice";	
	flagSeverity=1;
	;;	
	"6" )
	severity="info";	
	flagSeverity=1;
	;;
	"7" )
	severity="debug";	
	flagSeverity=1;
	;;
	* )
	echo "Invalid selection.";
	;;
esac

return;

}

#return to default state
function defaultState() {

#check if file not default
if [ -f $tempLoc"/syslog-ng_temp6" ]
then 
	rm $tempLoc"/syslog-ng_temp6";
fi
sed -n '/ --- syslog-ngConfigrator line for d_scp_p /p' $Loc"/syslog-ng.conf" > $tempLoc"/syslog-ng_temp6";
defaultSize_tmp=$(ls -l "$tempLoc/syslog-ng_temp6");
defaultSize=$(echo "${defaultSize_tmp}" | awk '{print $5}');

if [[ $defaultSize -gt 1 ]]
then
	sed -n '1,/ --- syslog-ngConfigrator line for d_scp_p /p' $tempLoc"/syslog-ng_temp4" > $tempLoc"/syslog-ng_temp6";
	sed '$d' $tempLoc"/syslog-ng_temp6" > $tempLoc"/syslog-ng_temp4"; #delete last line
fi

}

#changes syslog-ng file according to chosen modules and severity levels
function changeConf() {

flagSeverity=0; #opens the flag for "Choose severity" menu
while [[ $flagSeverity -eq 0 ]]
do
	severityMenu;
done
echo "";
echo "You chose severity level: $severity";

moduleMenuMain;

#split file into parts
sed -n '1,/ --- Destination for announicing/p' $Loc"/syslog-ng.conf" > $tempLoc"/syslog-ng_temp2";
sed '$d' $tempLoc"/syslog-ng_temp2" > $tempLoc"/syslog-ng_temp1"; #delete last line
sed -n '/ --- Destination for announicing/,/ --- Filters for announicing/p' $Loc"/syslog-ng.conf" > $tempLoc"/syslog-ng_temp3";
sed '$d' $tempLoc"/syslog-ng_temp3" > $tempLoc"/syslog-ng_temp2"; #delete last line
sed -n '/ --- Filters for announicing/,/Print sc_print /p' $Loc"/syslog-ng.conf" > $tempLoc"/syslog-ng_temp4";
sed '$d' $tempLoc"/syslog-ng_temp4" > $tempLoc"/syslog-ng_temp3"; #delete last line
sed -n '/Print sc_print /,/Print diagnostic status /p' $Loc"/syslog-ng.conf" > $tempLoc"/syslog-ng_temp5";
sed '$d' $tempLoc"/syslog-ng_temp5" > $tempLoc"/syslog-ng_temp4"; #delete last line
sed -n '/Print diagnostic status /,$p' $Loc"/syslog-ng.conf" > $tempLoc"/syslog-ng_temp5";

#check destination and filters in syslog-ng.conf file
if [ -f $tempLoc"/syslog-ng_temp6" ]
then 
	rm $tempLoc"/syslog-ng_temp6";
fi
sed -n '/d_scp_p/p' $Loc"/syslog-ng.conf" > $tempLoc"/syslog-ng_temp6";
size_tmp=$(ls -l "$tempLoc/syslog-ng_temp6");
size=$(echo "${size_tmp}" | awk '{print $5}');

#add destination and filters if they don't already exist
if [[ $size -le 1 ]]
then
	#add destination            
	echo "destination d_scp_p { file(\"/var/log/sc_print_p\" template(\"$MSGONLY\n\")); };" >> $tempLoc"/syslog-ng_temp1";
	echo "" >> $tempLoc"/syslog-ng_temp1";
	
	#add filters
	sed -n '/filter f_scp.emergency/p' $Loc"/syslog-ng.conf" > $tempLoc"/syslog-ng_temp6";
	size_tmp=$(ls -l "$tempLoc/syslog-ng_temp6");
	size=$(echo "${size_tmp}" | awk '{print $5}');
	if [[ $size -le 1 ]]
	then
		echo "filter f_scp.emergency { level(emerg); };" >> $tempLoc"/syslog-ng_temp2";
	fi
	sed -n '/filter f_scp.alert/p' $Loc"/syslog-ng.conf" > $tempLoc"/syslog-ng_temp6";
	size_tmp=$(ls -l "$tempLoc/syslog-ng_temp6");
	size=$(echo "${size_tmp}" | awk '{print $5}');
	if [[ $size -le 1 ]]
	then
		echo "filter f_scp.alert     { level(alert..emerg); };" >> $tempLoc"/syslog-ng_temp2";
	fi
	sed -n '/filter f_scp.critical/p' $Loc"/syslog-ng.conf" > $tempLoc"/syslog-ng_temp6";
	size_tmp=$(ls -l "$tempLoc/syslog-ng_temp6");
	size=$(echo "${size_tmp}" | awk '{print $5}');
	if [[ $size -le 1 ]]
	then
		echo "filter f_scp.critical  { level(crit..emerg); };" >> $tempLoc"/syslog-ng_temp2";
	fi
	sed -n '/filter f_scp.error/p' $Loc"/syslog-ng.conf" > $tempLoc"/syslog-ng_temp6";
	size_tmp=$(ls -l "$tempLoc/syslog-ng_temp6");
	size=$(echo "${size_tmp}" | awk '{print $5}');
	if [[ $size -le 1 ]]
	then
		echo "filter f_scp.error     { level(err..emerg); };" >> $tempLoc"/syslog-ng_temp2";
	fi
	sed -n '/filter f_scp.warning/p' $Loc"/syslog-ng.conf" > $tempLoc"/syslog-ng_temp6";
	size_tmp=$(ls -l "$tempLoc/syslog-ng_temp6");
	size=$(echo "${size_tmp}" | awk '{print $5}');
	if [[ $size -le 1 ]]
	then
		echo "filter f_scp.warning   { level(warning..emerg); };" >> $tempLoc"/syslog-ng_temp2";
	fi
	sed -n '/filter f_scp.notice/p' $Loc"/syslog-ng.conf" > $tempLoc"/syslog-ng_temp6";
	size_tmp=$(ls -l "$tempLoc/syslog-ng_temp6");
	size=$(echo "${size_tmp}" | awk '{print $5}');
	if [[ $size -le 1 ]]
	then
		echo "filter f_scp.notice    { level(notice..emerg); };" >> $tempLoc"/syslog-ng_temp2";
	fi
	sed -n '/filter f_scp.info/p' $Loc"/syslog-ng.conf" > $tempLoc"/syslog-ng_temp6";
	size_tmp=$(ls -l "$tempLoc/syslog-ng_temp6");
	size=$(echo "${size_tmp}" | awk '{print $5}');
	if [[ $size -le 1 ]]
	then
		echo "filter f_scp.info      { level(info..emerg); };" >> $tempLoc"/syslog-ng_temp2";
	fi
	sed -n '/filter f_scp.debug/p' $Loc"/syslog-ng.conf" > $tempLoc"/syslog-ng_temp6";
	size_tmp=$(ls -l "$tempLoc/syslog-ng_temp6");
	size=$(echo "${size_tmp}" | awk '{print $5}');
	if [[ $size -le 1 ]]
	then
		echo "filter f_scp.debug     { level(debug..emerg); };" >> $tempLoc"/syslog-ng_temp2";
	fi
	echo "" >> $tempLoc"/syslog-ng_temp2";
fi

#return to default state
defaultState;

#add line with chosen modules and severity
echo "# --- syslog-ngConfigrator line for d_scp_p start ---" >> $tempLoc"/syslog-ng_temp4";
for (( i=0 ; i < ${#MODULE[@]} ; i++ ))
do
	echo "log { source(${MODULE[$i]}); filter(f_scp.$severity); destination(d_scp_p); };" >> $tempLoc"/syslog-ng_temp4";
done
echo "# --- syslog-ngConfigrator line for d_scp_p end ---" >> $tempLoc"/syslog-ng_temp4";
echo "" >> $tempLoc"/syslog-ng_temp4";

#join all parts together into output file
cat $tempLoc"/syslog-ng_temp1" $tempLoc"/syslog-ng_temp2" $tempLoc"/syslog-ng_temp3" $tempLoc"/syslog-ng_temp4" $tempLoc"/syslog-ng_temp5" > $tempLoc"/out";

if [ -f $tempLoc"/out" ]
then 
	mv $tempLoc"/out" $Loc"/syslog-ng.conf";
	/etc/init.d/syslog-ng reload
else
	echo "";
	echo "Unable to write syslog-ng.conf!"
fi

echo "";
echo "File syslog-ng was changed. Look for logs in /var/log/sc_print_p";
echo "";
echo "AFTER you FINISH with the work, please run the script AGAIN and choose option 2: Return syslog-ng file to default state.";
echo "";
exit;

}

#returns syslog-ng file to default
function defaultConf() {

#split file into parts
sed -n '1,/ --- Destination for announicing/p' $Loc"/syslog-ng.conf" > $tempLoc"/syslog-ng_temp2";
sed '$d' $tempLoc"/syslog-ng_temp2" > $tempLoc"/syslog-ng_temp1"; #delete last line
sed -n '/ --- Destination for announicing/,/ --- Filters for announicing/p' $Loc"/syslog-ng.conf" > $tempLoc"/syslog-ng_temp3";
sed '$d' $tempLoc"/syslog-ng_temp3" > $tempLoc"/syslog-ng_temp2"; #delete last line
sed -n '/ --- Filters for announicing/,/Print sc_print /p' $Loc"/syslog-ng.conf" > $tempLoc"/syslog-ng_temp4";
sed '$d' $tempLoc"/syslog-ng_temp4" > $tempLoc"/syslog-ng_temp3"; #delete last line
sed -n '/Print sc_print /,/Print diagnostic status /p' $Loc"/syslog-ng.conf" > $tempLoc"/syslog-ng_temp5";
sed '$d' $tempLoc"/syslog-ng_temp5" > $tempLoc"/syslog-ng_temp4"; #delete last line
sed -n '/Print diagnostic status /,$p' $Loc"/syslog-ng.conf" > $tempLoc"/syslog-ng_temp5";

#return to default state
defaultState;

#join all parts together into output file
cat $tempLoc"/syslog-ng_temp1" $tempLoc"/syslog-ng_temp2" $tempLoc"/syslog-ng_temp3" $tempLoc"/syslog-ng_temp4" $tempLoc"/syslog-ng_temp5" > $tempLoc"/out";

if [ -f $tempLoc"/out" ]
then 
	mv $tempLoc"/out" $Loc"/syslog-ng.conf";
	/etc/init.d/syslog-ng reload
else
	echo "";
	echo "Unable to write syslog-ng.conf!"
fi

echo "";
echo "File syslog-ng file was returned to default state.";
exit;

}

#PROGRAM START POINT

if [ "$1" = "help" ] || [ "$1" = "Help" ] || [ "$1" = "-help" ] || [ "$1" = "-Help" ] || [ "$1" = "--help" ] || [ "$1" = "--Help" ]
then
	f_help;
	exit;
fi

#temporary location
tempLoc="/tmp";
#syslog-ng.conf location
Loc="/etc/syslog-ng";

if [[ -f $Loc"/syslog-ng.conf" ]]
then 		
	:
else
	echo;
	echo "File $Loc/syslog-ng.conf does not exist!";
	echo;
	exit;
fi

#displays program title
echo;
echo "######################################";
echo "##SYSLOG-NG CONFIGURATOR version 1.2##";
echo "######################################";

#PROGRAM MAIN LOOP
while true
do	
	mainMenu;
done